#ifdef _WIN32
#include <windows.h>             //bit ce ukljuceno ako se koriste windows
#endif

//  #include <GL/Gl.h>
//  #include <GL/Glu.h>    nije potrebno ako se koristi glut
#include <GL/glut.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

//*********************************************************************************
//	Pokazivac na glavni prozor i pocetna velicina.
//*********************************************************************************

GLuint window; 
GLuint sub_width = 256, sub_height = 256;

//*********************************************************************************
//	Function Prototypes.
//*********************************************************************************

void init		();
void myDisplay		();
void myReshape		(int width, int height);

//*********************************************************************************
//	Glavni program.
//*********************************************************************************

int main(int argc, char ** argv)
{

	glutInitDisplayMode(GLUT_SINGLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(sub_width,sub_height);
	glutInitWindowPosition(100,100);
	glutInit(&argc, argv);

	window = glutCreateWindow("Glut OpenGL primjer");
	glutReshapeFunc(myReshape);
	glutDisplayFunc(myDisplay);

	init();

	glutMainLoop();
    	return 0;
}

void init() {
	// Bijela boja za pozadinu slike: RGBA = 1,1,1,1 (a=1: opaque, a=0: transparent)
	glClearColor(1.0, 1.0, 1.0, 1.0);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	//Ovo ispod je defaultni volumen pogleda pa ne trebamo naredbu...
	//glOrtho(-1.0, 1.0, -1.0, 1.0, 1.0, -1.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glEnable(GL_DEPTH_TEST);
}

//*********************************************************************************
//	Osvjezavanje prikaza. (nakon preklapanja prozora) 
//*********************************************************************************

void myDisplay()
{
 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPointSize(1.0);

	glMatrixMode(GL_MODELVIEW);			// matrica modela
	glLoadIdentity();

	glBegin(GL_TRIANGLES);
	// Prvi trokut:
	glColor3f(1.0f, 0.0f, 0.0f);
	glVertex3f(-0.9f, -0.9f, -0.9f);
	glVertex3f( 0.9f, -0.9f, -0.9f);
	glVertex3f( 0.0f,  0.9f,  0.9f);

	// Drugi trokut:
	glColor3f(0.0f, 1.0f, 0.0f);
	glVertex3f(-0.9f,  0.9f, -0.9f);
	glVertex3f( 0.9f,  0.9f, -0.9f);
	glVertex3f( 0.0f, -0.9f,  0.9f);
	glEnd();

	glFlush();
}

//*********************************************************************************
//	Promjena velicine prozora.
//*********************************************************************************

void myReshape(int width, int height)
{
	sub_width = width;                      	// zapamti novu sirinu prozora
    	sub_height = height;				// zapamti novu visinu prozora

    	glViewport(0, 0, sub_width, sub_height);	// otvor u prozoru

	glMatrixMode(GL_PROJECTION);			// matrica projekcije
	glLoadIdentity();				// jedinicna matrica
}

