#ifdef _WIN32
#include <windows.h>             //bit ce ukljuceno ako se koriste windows
#endif

//  #include <GL/Gl.h>
//  #include <GL/Glu.h>    nije potrebno ako se koristi glut
#include <GL/glut.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>

//*********************************************************************************
//	Pokazivac na glavni prozor i pocetna velicina.
//*********************************************************************************

GLuint window; 
GLuint sub_width = 256, sub_height = 256;
int kut = 0;
int delta = 2;
double eyez = 3;
double eyex = 0;
double eyey = 0;

//*********************************************************************************
//	Function Prototypes.
//*********************************************************************************

void init		();
void myDisplay		();
void myReshape		(int width, int height);
void myAnimate          (int value);

//*********************************************************************************
//	Glavni program.
//*********************************************************************************

int main(int argc, char ** argv)
{

	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB | GLUT_DEPTH);
	glutInitWindowSize(sub_width,sub_height);
	glutInitWindowPosition(100,100);
	glutInit(&argc, argv);

	window = glutCreateWindow("Glut OpenGL primjer");
	glutReshapeFunc(myReshape);
	glutDisplayFunc(myDisplay);

	init();

	glutTimerFunc(20, myAnimate, 0);

	glutMainLoop();
    	return 0;
}

void init() {
	// Bijela boja za pozadinu slike: RGBA = 1,1,1,1 (a=1: opaque, a=0: transparent)
	glClearColor(1.0, 1.0, 1.0, 1.0);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(-1.0, 1.0, -1.0, 1.0, 1.0, 8.0);

	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	glEnable(GL_DEPTH_TEST);
}

void myAnimate(int value) {
	kut += delta;
	if(kut>360) kut -= 360;
	eyez = 3 * cos(M_PI/180.0*kut);
	eyex = 3 * sin(M_PI/180.0*kut);
	eyey = 1 * sin(8*M_PI/180.0*kut);
	glutPostRedisplay();
	glutTimerFunc(20, myAnimate, 0);
}

//*********************************************************************************
//	Osvjezavanje prikaza. (nakon preklapanja prozora) 
//*********************************************************************************

void myDisplay()
{
 	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glPointSize(1.0);

	glMatrixMode(GL_MODELVIEW);			// matrica modela
	glLoadIdentity();
	gluLookAt(eyex,eyey,eyez, 0.0,0.0,0.0, 0.0,1.0,0.0);

	glBegin(GL_TRIANGLES);
	// Prvi trokut:
	glColor3f(1.0f, 0.0f, 0.0f);
	glVertex3f(-0.9f, -0.9f, -0.9f);
	glVertex3f( 0.9f, -0.9f, -0.9f);
	glVertex3f( 0.0f,  0.9f,  0.9f);

	// Drugi trokut:
	glColor3f(0.0f, 1.0f, 0.0f);
	glVertex3f(-0.9f,  0.9f, -0.9f);
	glVertex3f( 0.9f,  0.9f, -0.9f);
	glVertex3f( 0.0f, -0.9f,  0.9f);
	glEnd();

	glutSwapBuffers();
}

//*********************************************************************************
//	Promjena velicine prozora.
//*********************************************************************************

void myReshape(int width, int height)
{
	sub_width = width;                      	// zapamti novu sirinu prozora
    	sub_height = height;				// zapamti novu visinu prozora

    	glViewport(0, 0, sub_width, sub_height);	// otvor u prozoru

	glMatrixMode(GL_PROJECTION);			// matrica projekcije
	glLoadIdentity();				// jedinicna matrica
	glOrtho(-1.0, 1.0, -1.0, 1.0, 1.0, 8.0);
}

